=== debian/changelog ===
glhack (1.2-9) unstable; urgency=medium

  * Ack NMU, thanks Adrian
  * Drop "Rules-Requires-Root: no"
  * Bump Standards-Version to 4.7.3, drop Priority: tag
  * Add debian/salsa-ci.yml
  * Rewrite d/copyright in machine-parsable format

 -- Alexandre Detiste <tchet@debian.org>  Sun, 11 Jan 2026 20:53:28 +0100

glhack (1.2-8.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    (Closes: #1096720)

 -- Adrian Bunk <bunk@debian.org>  Thu, 02 Oct 2025 13:44:27 +0300

glhack (1.2-8) unstable; urgency=medium

  * Adopt the game and it's bugs inside Games Team (Closes: #607323)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 02 Apr 2025 10:02:42 +0200

glhack (1.2-7) unstable; urgency=medium

  * QA upload.
  * Migrate to `debputy` to remove the need for `(fake)root` to
    perform static ownership.
  * Convince upstream's Makefile to not chown/chgrp paths as
    the Debian packaging will handle that via `debputy`.
  * Set `Rules-Requires-Root: no` due to the above changes.

 -- Niels Thykier <niels@thykier.net>  Fri, 14 Jun 2024 11:13:46 +0000

glhack (1.2-6) unstable; urgency=medium

  * QA upload.

  * Removed unused d/desktop file, prefer the d/glhack.desktop file
    over debian menu file.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 17 Apr 2024 23:11:06 +0200

glhack (1.2-5) unstable; urgency=medium

  * QA upload.

  * Updated vcs in d/control to Salsa.
  * Added d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 4.1.3 to 4.7.0.
  * Replaced obsolete build dependency libncurses5-dev with libncurses-dev.
  * Updated to debhelper compat level 13.  Disabled parallel execution.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 17 Apr 2024 08:23:30 +0200

glhack (1.2-4) unstable; urgency=medium

  * QA upload.
  * R³: yes.
  * dh 11.
  * Priority: optional.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 11 Feb 2018 14:18:36 +0100

glhack (1.2-3) unstable; urgency=medium

  * QA upload.
  * Drop debian/README.sources, this is a "3.0 (quilt)" package now.
  * Do not call update-menus directly in postinst, as debhelper already
    inserts a suitable call via #DEBHELPER#.
  * debian/rules: Add override_dh_fixperms and really make the program
    to be set-gid games. Closes: #783376.
  * Renumber and clean up debian/patches/* with the help of "diff -w".
  * Add debian/patches/09-reproducible-build.patch. Change util/makedefs.c
    to not define or use the build date.
  * Add debian/patches/10-comp-times.patch. Change src/version.c so that
    comp_times() function always returns 0.
  * Standards-Version: 3.9.6.

 -- Santiago Vila <sanvila@debian.org>  Fri, 11 Sep 2015 16:00:30 +0200

glhack (1.2-2) unstable; urgency=low

  * QA upload.
  * Orphan package and set maintainer to QA group; see bugs #664341
    and #607323 for previous maintainer's approval.
  * Remove deprecated dpatch and upgrade to packaging format "3.0 quilt"
    (Closes: #664341).
  * Update Standards-Version to 3.9.4 and debhelper to 9. Update to
    libpng-dev; thanks to Nobuhiro Iwamatsu <iwamatsu@nigauri.org>
    (Closes: #662349).
  * Add desktop file (Closes: #661315). Patch thanks to
    Paul Wise <pabs@debian.org>.
  * Convert debian/rules to dh(1). Setgid binaries to games (Closes: #546986).
  * Use hardened build flags
    <http://wiki.debian.org/ReleaseGoals/SecurityHardeningBuildFlags>.
  * Patches:
    (01): Refresh to pass MANDIR in call to doc/Makefile.
    (02): Refresh to apply cleanly under new packaging format.
    (10): New. To make build pass hardened build flag.
    (20): New. FTBFS by libpng 1.5 (Closes: #649948). Patch thanks
    to Nobuhiro Iwamatsu <iwamatsu@nigauri.org>.

 -- Jari Aalto <jari.aalto@cante.net>  Sat, 04 May 2013 09:05:23 +0300

glhack (1.2-1) unstable; urgency=low

  Initial release (Closes: #528034)

 -- Stefan Ritter <xeno@thehappy.de>  Tue, 23 Jul 2009 14:41:20 +0200
