=== debian/control ===
Source: glhack
Section: games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <tchet@debian.org>,
Homepage: http://glhack.sourceforge.net/
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-zz-debputy-rrr (>= 0.1.35~),
 bison,
 flex,
 libncurses-dev,
 libpng-dev,
 libsdl1.2-dev,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/games-team/glhack
Vcs-Git: https://salsa.debian.org/games-team/glhack.git
X-Style: black

Package: glhack
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fullscreen SDL/OpenGL version of NetHack
 glHack is a port of the game NetHack, using hardware acceleration via
 OpenGL(R) to render the 2D tile graphics.  It uses LibSDL as the video
 and input library.  There is good support for software rendering
 (without OpenGL) as well.
 .
 glHack is just one of the many NetHack front-ends.  Others include the
 original text-terminal (TTY) version, one for the X Window System, and
 one for GNOME called GnomeHack.
 .
 See the official NetHack website for complete information about the actual
 game.
