=== debian/watch ===
version=4

http://sf.net/glhack/glhack-(.*)\.tar\.gz
